// -*-c++-*-
//===========================================================
//=     University of Illinois at Urbana/Champaign          =
//=     Department of Computer Science                      =
//=     Dr. Dan Roth - Cognitive Computation Group          =
//=                                                         =
//=  Project: Snow                                          =
//=                                                         =
//=   Module: Perceptron.h                                  =
//=  Version: 2.1                                           =
//=  Authors: Jeff Rosen, Andrew Carlson                    =
//=     Date: xx/xx/99                                      = 
//=                                                         =
//= Comments:                                               =
//===========================================================

#ifndef __PERCEPTRON_H__
#define __PERCEPTRON_H__

#include "LearningAlgorithm.h"

class Perceptron : public LearningAlgorithm
{
public:
    Perceptron( double learningRate = 0.10,
                double threshold = 1.0,
                double defaultWeight = 0.10 );

    bool PresentExample( Target& tar, Example& ex );
    void TrainingComplete( Target& tar );

    // Updates the target based on the example and the Perceptron parameters
    void Update( Target& tar, Example& ex );

    void SetTargetActivation( Target& tar, Example& ex );
    double ReturnNormalizedActivation( Target& tar);

    void Show( ostream& out );
    
    void Read( ifstream& in );
    void Write( ofstream& out );
    
private:
    double  learningRate;
};

inline Perceptron::Perceptron( double lr, double th, double dw ) :
        LearningAlgorithm(th, dw),
        learningRate(lr)
{
}

inline void Perceptron::TrainingComplete( Target& tar )
{
}

#endif
